﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;
using System.IO;
using System;


public class MetaDataText_v3 : MonoBehaviour
{
    //public GameObject[] Row;
    public GameObject TableList; 
    public GameObject modelwithinfo;
    public List<GameObject> Children;
    //line number
    

    void Start()
    {
        PiXYZ.Import.Metadata list = modelwithinfo.GetComponent<PiXYZ.Import.Metadata>();
        
        Transform[] allChildren = TableList.GetComponentsInChildren<Transform>();
        foreach (Transform child in allChildren)
        {
            if (child.tag == "Row")
            {
                Children.Add(child.gameObject);
            }
        }

        List<string> ReferenceList = new List<string>();
        
        string[] ReferenceLines = { 
            "No. оборудования по технологической схеме",
            "Инвентарный No. оборудования",
            "Рабочее давление, МПа",
            "Давление номинальное PN, кгс/см2",
            "Пропускная способность установки по жидкости",
            "Плотность",
            "Объем, м³",
            "Мощность насоса, кВт",
            "Мощность силового трансформатора, кВА ",
            "Тип",
            "Материалы конструкции",
            "Объем, м3",
            "Рабочая среда",
            "Тепловая мощность, МВт(Гкал/ч), не более",
            "Высота факела, м",
            "Номинальное напряжение на стороне ВН, кВ",
            "Номинальный объем, м³",
            "Размер дозы, г/т",
            "Подача, м.куб./час",
            "Измеряемая среда",
            "Подача, м³/ч",
            "Давление, МПа",
            "Диаметр входных патрубков, мм",
            "Диаметр номинальный DN ",
            "Рабочее давление установки",
            "Кинематическая вязкость",
            "Давление условное, Мпа",
            "Предельное давление (наибольшее), Мпа",
            "Номинальное напряжение на стороне ВН, кВ ",
            "Строение",
            "Число ходов балансира в мин.",
            "Общий вес, кг",
            "Температура печи, °С",
            "Расчетное давление, МПа,",
            "Номинальная производительность, кг/с (т/ч)",
            "Сжигаемая среда",
            "Наибольшее рабочее напряжение (линейное), кВ:",
            "Внутренний диаметр стенки, мм",
            "Вязкость дозируемой среды, Мпа*с.",
            "Напор, м.в.ст.",
            "Диаметр условного прохода, мм",
            "Напор, м",
            "Производительность по газу м³/час ",
            "Диаметр общего выходного патрубка,мм",
            "Тип конструкции проточной части корпуса",
            "Разделение потока в установке",
            "Содержание Н2S",
            "Количество каплеуловителей,  П",
            "Частота вращения трансмиссионного вала, об/мин",
            "Номинальное напряжение на стороне НН, кВ ",
            "Допускаемый кавитационный запас,м",
            "Двигатель привода барабана, кВт",
            "Процент обводненности нефти на выходе, % не более",
            "Производительность по жидкости, м3/сут",
            "Температура продукта: на входе в печь, °С, не менее",
            "Низшая теплотворная способность, ккал/кг",
            "Номинальный ток плавкой вставки предохранителей, А",
            "Высота стенки, мм",
            "Подача дозировочного насоса, л/ч.",
            "Мощность, кВт",
            "Давление измеряемой среды, Мпа",
            "Количество подключаемых трубопроводов",
            "Тип затвора ",
            "Комплектация установки мультифазными расходомерами",
            "Класс опасности среды",
            "Диаметр, Dв, мм",
            "Диаметр сменных втулок, мм",
            "Вид силового трансформатора ",
            "Глубина, м",
            "Редуктор",
            "Частота вращения, об/мин",
            "Двигатель привода шнека, кВт",
            "Производительность по газу, м3/сут",
            "Температура продукта: на выходе из печи, °С, не более",
            "Коэффициент излучения",
            "Номинальный ток трансформаторов тока, А",
            "Расчетная высота налива, мм",
            "Температура дозируемого реагента, °С.",
            "Обороты",
            "Температура измеряемой среды, °C",
            "Мощность двигателя, кВт",
            "Гарантия ",
            "Максимальный перепад давления между замерным и общим трубопроводом, МПа, не более",
            "Тип управления ",
            "Количество подключаемых скважин",
            "Категория и группа взрывозащищенности жидкости",
            "Толщина стенки, днища, K, Sд, мм",
            "Ход поршня, мм",
            "Потребляемая мощность, кВт",
            "Габаритные размеры (Д x Ш x В), мм",
            "Массовая концентрация жидкости в очищенном газе, г/ м3",
            "Рабочее давление, МПа (кгс/см2)",
            "Относительная влажность, %",
            "Номинальный ток отключения выключателей, кА",
            "Стенка РВС–100 Количество поясов, шт",
            "Стенка РВС–400 Количество поясов, шт",
            "Стенка РВС–5000 Количество поясов, шт",
            "Стенка РВС–10000 Количество поясов, шт",
            "Габариты, мм",
            "Погрешность измерительного канала, %",
            "Диаметр измерительного патрубка",
            "Установочное  положение задвижек на трубопроводе",
            "Срок службы установки",
            "Температура рабочей среды",
            "Длина, L, мм",
            "Передаточное число зубчатой передачи",
            "КПД насоса, %",
            "Температура окружающей среды, °С",
            "Коэффициент полезного действия, %",
            "Скорость ветра, м/с",
            "Ток электродинамической стойкости, кА",
            "Стенка РВС–100 Толщина верхнего пояса, мм",
            "Стенка РВС–400 Толщина верхнего пояса, мм",
            "Стенка РВС–5000 Толщина верхнего пояса, мм",
            "Стенка РВС–10000 Толщина верхнего пояса, мм",
            "Напряжение питания постоянного тока, В",
            "Напряжение питания датчика положения, В",
            "Коэффициент сопротивления,  не более",
            "Гарантия и сервисное обслуживание установки",
            "Объемная производительность по нефти, м³/ч",
            "Диаметр шкива насоса (расчетный), мм",
            "Диаметр, мм",
            "Количество блоков в печи, шт.",
            "Длина пламени при максимальном расходе (L), м",
            "Степень защиты по ГОСТ 14254-96",
            "Стенка РВС–100 Толщина нижнего пояса, мм",
            "Стенка РВС–400 Толщина нижнего пояса, мм",
            "Стенка РВС–5000 Толщина нижнего пояса, мм",
            "Стенка РВС–10000 Толщина нижнего пояса, мм",
            "Интервал между поверками, год",
            "Род тока",
            "Присоединение к трубопроводу ",
            "Срок изготовления и поставки установки",
            "Объемная производительность по газу м³/ч",
            "Диаметр всасывающего патрубка, мм",
            "Максимальная пропускная способность, м3/ч",
            "Масса насоса, кг",
            "Расстояние от центра излучения до оси факела (DX), м",
            "Уровень изоляции по ГОСТ1516.1-76",
            "Днище РВС–100 Толщина центральной части, мм",
            "Днище РВС–400 Толщина центральной части, мм",
            "Днище РВС–5000 Толщина центральной части, мм",
            "Днище РВС–10000 Толщина центральной части, мм",
            "Диапозон температуры окружающей среды, 0С",
            "Диаметр нагнетательного патрубка, мм",
            "Тип насоса",
            "Расход топливного газа, м3/с (м3/ч)",
            "Расстояние от центра излучения до наконечника факела (DY), м",
            "Крыша РВС–100 Толщина настила, мм",
            "Крыша РВС–400 Толщина настила, мм",
            "Крыша РВС–5000 Толщина настила, мм",
            "Крыша РВС–10000 Толщина настила, мм",
            "Относительная влажность окружающей среды при температуре +20 0С, %, не более",
            "Масса, кг, не более",
            "Дата установки ",
            "Фирма, завод-изготовитель ",
            "Заводской номер ",
            "Дата выпуска оборудования ",
            "Дата составления паспорта",
            "Сметная стоимость, тг.",
            "Высота оборудования, мм",
            "Длина оборудования, мм",
            "Ширина оборудования, мм",
            "Объем оборудования, куб.м",
            "Количество элементов ",
            "Диаметр оборудования, мм ",
            "Глубина заложения горловины подземного оборудования, мм "};  

        ReferenceList.AddRange(ReferenceLines);   
        

        var list2 = list.getProperties();
        List<string> namelist = new List<string>();
        List<string> propertieslist = new List<string>();
        List<string> namelistwithprefix = new List<string>();

        Dictionary<string, string>.KeyCollection keys = list2.Keys; 
        foreach (string a in keys)
        {
            if(a.StartsWith("Текст/") || a.StartsWith("Размеры/"))
            {
                propertieslist.Add(list2[a]);
                namelistwithprefix.Add(a);
            }
        }
        
        foreach (string a in namelistwithprefix)
        {
            if(a.StartsWith("Текст/"))
            {
                char[] wordsone = {'Т','е','к','с','т','/'};
                string nameone = a.TrimStart(wordsone);
                namelist.Add(nameone);
                
            }
            else if(a.StartsWith("Размеры/"))
            {
                char[] wordstwo = {'Р','а','з','м','е','р','ы','/'};
                string nametwo = a.TrimStart(wordstwo);
                namelist.Add(nametwo);
            }
        }

        
        List<string> cleannamelist = new List<string>();

        for(int i = 0;i<ReferenceList.Count;i++)
        {
            cleannamelist.Add(" ");
        }
        

        List<string> cleanproplist = new List<string>();

        for(int i = 0;i<ReferenceList.Count;i++)
        {
            cleanproplist.Add(" ");
        }
        
        List<int> indexes = new List<int>();


        for(int i = 0;i<namelist.Count; i++)
        {
            int index = ReferenceList.FindIndex(a => a.Contains(namelist[i]));
            if (index >= 0)
            {
                indexes.Add(index);
            }
        }

        List<string> newnamelist = new List<string>();

        foreach(string a in namelist)
        {
            newnamelist.Add(a);
        }


        foreach(string b in namelist)
        {
            int index = ReferenceList.FindIndex(a => a.Contains(b));
            int index2 = namelist.FindIndex(a => a.Contains(b));

            if (index < 0)
            {
                newnamelist.RemoveAt(index2);
                propertieslist.RemoveAt(index2);
            }
        }
        
        for(int i = 0;i<indexes.Count; i++)
        {
            cleannamelist[indexes[i]] = newnamelist[i];
            cleanproplist[indexes[i]] = propertieslist[i];
        }

        int mynum = cleannamelist.Count;
        List<string> FinalListname = new List<string>();
        for(int i = 0; i<mynum; i++)
        {
            if(cleannamelist[i]!= " ")
            {
                FinalListname.Add(cleannamelist[i]);
            }
        }

        List<string> FinalListprop = new List<string>();
        for(int i = 0; i<mynum; i++)
        {
            if(cleanproplist[i]!= " ")
            {
                FinalListprop.Add(cleanproplist[i]);
            }
        }

        int peremennaya;
        peremennaya = FinalListname.Count;
        for (int i=0; i<peremennaya ;i++)
        {
            TextMeshProUGUI[] Text = Children[i].GetComponentsInChildren<TextMeshProUGUI>();

            Text[1].text = FinalListprop[i];
            Text[0].text = FinalListname[i];
            
        }
        //Debug.Log("Finish");
    }
}
